// sn-proxy.js
// Copyright (c) 2012-2013 Smithee, Spelvin, Angew & Plinge

                require( 'sn-core' );
var props     = require( 'sn-props' );
var fs        = require( 'fs' );
var spawn     = require( 'child_process' ).spawn;
var os        = require( 'os' );

var interfaces = os.networkInterfaces();

( new props( { global: 'file:///etc/proxyroutes.json'} ) ).read( function( properties ) {
  properties._$each( function( e ) {
    if( e && e.ssl ) {
      e.router = _buildRouter( e.router );
      e.router.localhost = {};
      e.router._$each( function( e, i ) {
        var found = false;

        try {
          fs.statSync( i + ".crt" );
          fs.statSync( i + ".key" );
          console.log( "found existing key and cert for " + i + "." );
          found = true;
        } catch( err ) {
            found = false;
        }

        if( ! found ) {
          console.log( "generating self-signed certificate & key for " + i + ".");
          spawn( '../bin/gssc', [ i ] );
        }
      } );
    }
  } );
} );

function _buildRouter( input ) {
    var output = {};
    input._$each && input._$each( function( e, i ) {
	if( '#' == i.substr( 0, 1 ) ) {
	    var ip = _findInterface( i.substr( 1 ) );
	    if( ip ) {
		output[ ip ] = e;
	    }
	} else {
	    output[ i ] = e;
	}
	
    } );
    return output;
}

function _findInterface( iface ) {
    var ip;
    interfaces[ iface ] && interfaces[ iface ]._$each && interfaces[ iface ]._$each( function( e ) {
	if( e && e.family && ( 'IPv4' == e.family ) && e.address ) {
	    ip = e.address;
	    return true;
	}
    } );
    return ip;
}
